<template>
	<view :class="[AppTheme]">
		<view v-if="!ifpeon">
			<u-empty margin-top="60" text="您还未进行实名认证" mode="order"></u-empty>
			<view class="goreins" @click="gopenre()">点击去实名认证</view>
		</view>
		<view v-if="ifpeon">
			<u-loading-icon :show="login" mode="semicircle" size="30" class="loading"></u-loading-icon>
			<view v-if="!login">
				<navigator url="/pagesD/pages/address/address?source=1" class="address-section" v-if="flag">
					<view class="order-content">
						<view class="cen" v-if="addressData">
							<view class="top" style="display: flex;justify-content: left;padding: 5rpx;">
								<u-icon name="phone" color="#2979ff" labelSize="16" labelColor="#191919"
									:label="(addressData.name||'')+' '+(addressData.mobile||'')" size="20"></u-icon>
							</view>
							<view style="display: flex;justify-content: left;padding: 5rpx;">
								<u-icon name="map" color="#2979ff" labelSize="12" labelColor="#a7a7a7"
									:label="(addressData.address||'')+(addressData.area||'')" size="20"></u-icon>
							</view>
						</view>
						<view class="cen" v-else>
							<view class="top">请选择收货地址...</view>
						</view>
						<text class="yticon icon-you"></text>
					</view>
					<image class="a-bg"
						src="data:image/png;base64, ">
					</image>
				</navigator>
				<!-- 自提点-->
				<view class="ziti" v-if="!flag">
					<view class="ziti_city">
						<view class="not-arrow" @click="show_0 = true">
							<span>{{ city[0].name || '省份' }}</span>
							<u-picker :show="show_0" :columns="province" @confirm="get_city" keyName="name"></u-picker>
						</view>
						<view class="not-arrow" @click="show_1 = true">
							<span>{{ city[1].name || '城市' }}</span>
							<u-picker :show="show_1" :columns="province_area" @confirm="get_area" keyName="name">
							</u-picker>
						</view>
						<view class="not-arrow" @click="show_2 = true">
							<span>{{ city[2].name || '地区' }}</span>
							<u-picker :show="show_2" :columns="province_twon" @confirm="get_twon" keyName="name">
							</u-picker>
						</view>
					</view>
					<view class="search_pickup" @click="search_pickup">自提点查询</view>
					<view class="since"></view>
					<view v-html="demoHtml" style="list-style: none;padding: 20rpx;"></view>
				</view>
				<view class="goods-section">
					<!-- 商品列表 -->
					<view class="g-item" v-for="(item, index) in orderList.result.goodslist" :key="index">
						<image :src=" item.pic"></image>
						<view class="right">
							<u--text lines="2" lineHeight="20" :text="item.name"></u--text>
							<u--text color="$font-color-light" size="13" lineHeight="20" :text="item.skuattr"></u--text>
							<view class="price-box">
								<view class="price">￥{{ item.price }}</view>
								<!-- 有疑问-->
								<view class="number">x {{ item.num }}</view>
							</view>
						</view>
					</view>
				</view>
				<!-- 优惠明细 -->
				<view class="yt-list">
					<view class="yt-list-cell b-b" @click="toggleMask('show')">
						<view class="cell-icon">券</view>
						<text class="cell-tit clamp">优惠券</text>
						<text class="cell-tip active">{{ clamp }}</text>
						<text class="cell-more wanjia wanjia-gengduo-d"></text>
					</view>
					<view class="yt-list-cell b-b">
						<view class="cell-icon hb">减</view>
						<text class="cell-tit clamp">商家促销</text>
						<text class="cell-tip disabled">商家暂无促销</text>
					</view>
				</view>
				<!-- 金额明细 -->
				<view class="yt-list">
					<view class="yt-list-cell b-b">
						<text class="cell-tit clamp">商品金额</text>
						<text class="cell-tip">￥{{ orderList.totalprice }}</text>
					</view>
					<view class="yt-list-cell b-b">
						<text class="cell-tit clamp">会员折扣</text>
						<text class="cell-tip  text-neutral">-￥{{ orderList.vipzkmoney }}</text>
					</view>
					<view class="yt-list-cell b-b">
						<text class="cell-tit clamp">总优惠金额</text>
						<text class="cell-tip  text-neutral">-￥{{ preferential+orderList.vipzkmoney }}</text>
					</view>
					<view class="yt-list-cell b-b">
						<text class="cell-tit clamp">运费</text>
						<text class="cell-tip">{{ '￥' + orderList.yf || '免运费' }}</text>
					</view>
					<view class="yt-list-cell desc-cell">
						<text class="cell-tit clamp">备注</text>
						<input class="desc" type="text" v-model="desc" placeholder="请填写备注信息"
							placeholder-class="placeholder" />
					</view>
				</view>
				<!-- 底部 -->
				<view class="footer">
					<view class="price-content">
						<text>实付款</text>
						<text class="price-tip text-neutral">￥</text>
						<text class="price text-neutral">{{ orderList.payprice }}</text>
					</view>
					<text class="submit bg-linear-gradient" @click="submit">提交订单</text>
				</view>
				<!-- 优惠券面板 -->
				<yhcoupon ref="yh_coupon" :orderList="orderList" :showModal="showPay" @close="onclose"></yhcoupon>
			</view>
		</view>
		<payment ref="payment" :channel="1" :alipay="true" :weixinpay="true" :zhtpay="true" :ncb="istd"></payment>
	</view>
</template>
<script>
	import api from '@/api/mall/index.js';
	import cart from '@/api/cart/index.js';
	import api_address from '@/api/address/address.js';
	import yhcoupon from '@/components/nx-coupon/yh_coupon.vue';
	export default {
		components: {
			yhcoupon
		},
		data() {
			return {
				istd: false,
				primary: this.$theme.primary,
				maskState: 0, //优惠券面板显示状态
				desc: '', //备注
				payType: 1, //1微信 2支付宝
				province: [],
				clone: '',
				login: true,
				province_area: [],
				province_twon: [],
				city: [{
						s: '0',
						name: ''
					},
					{
						b: '0',
						name: ''
					},
					{
						m: '0',
						name: ''
					}
				],
				ifpeon: true,
				show_0: false,
				show_1: false,
				show_2: false,
				orderList: '',
				addressData: '',
				num: 1,
				isact: '',
				settingFile: getApp().globalData.siteinfo,
				flag: true,
				demoHtml: '',
				preferential: 0,
				clamp: '暂无优惠券',
				djqid: 0,
				goodids: '',
				ftype: '',
				payparams: {

				},
				showPay: false,
				opayprice: 0
			};
		},
		onLoad(option) {
			option.ftype ? this.ftype = option.ftype : this.ftype = ""
			option.isact ? this.isact = option.isact : this.isact = ""
			option.goodsid ? this.goodids = option.goodsid : this.goodids = ""
			this.getAddressData(option);
		},
		computed: {
			sum() {
				return this.orderList.score * this.num;
			},
			actual() {
				return this.orderList.score * this.num - 35;
			}
		},
		methods: {
			onclose(item) {
				console.log('item', JSON.stringify(item));
				this.showPay = item.show;
				if (item.money == -2) {
					this.orderList.payprice = this.opayprice;
					this.preferential = 0;
					this.clamp = '暂不使用优惠券'
				} else if (item.money > 0) {
					this.clamp = -item.money
					this.preferential = item.money;
					this.orderList.payprice = this.opayprice - item.money;
					this.djqid = item.djqid;
					this.clone.payprice = this.orderList.payprice
				}
			},
			gopenre() {
				uni.redirectTo({
					url: '/pagesD/pages/set/renzheng/renzheng'
				});
			},
			orderMake() {

				let that = this;
				/* 判断pay页面 支付方式 */
				let delivery = that.flag == true ? 'express' : 'since';
				const userInfo = uni.getStorageSync('userInfo');
				/* 参数 */
				var obj = {
					sid: 0,
					goodstype: that.orderList.cache[0].goodstype,
					vipid: that.addressData.vipid,
					vipopenid: userInfo.openid,
					vipname: encodeURI(that.addressData.name),
					vipaddress: encodeURI(that.addressData.address),
					vipmobile: that.addressData.mobile,
					totalnum: that.clone.totalnum, //  克隆出的参数
					totalprice: that.clone.totalprice, //  克隆出的参数
					djqid: that.djqid,
					isact: that.isact,
					groupid: that.$store.state.groupid,
					delivery,
					goodids: that.goodids,
					address: that.orderList.vip.id,
					sinceid: 0,
					bid: that.orderList.bid,
					items: encodeURI(that.orderList.allitems),
					province: that.city[0].s,
					city: that.city[1].b,
					district: that.city[2].m,
					msg: encodeURI(that.desc),
				};
				if (that.ftype) {
					obj.ftype = that.ftype
				}
				/* 生成订单 */
				api.shop_orderMake_post(obj).then(res => {
					console.log('shop_orderMake_post', res)
					if (res.status == 200) {
						that.$refs.payment.payopen({
							orderid: res.data.orderid,
							djqid: that.djqid,
							money: that.clone.payprice
						});
					} else {
						uni.showToast({
							title: res.msg,
							icon: "none"
						});
					}
				});

			},
			get_city(e) {
				this.city[0].s = e[0].value;
				this.city[0].name = e[0].label;
				let parent_id = this.city[0].s;
				if (parent_id == 0) {
					return;
				}
				api.getRegion({
					level: 2,
					parent_id: parent_id
				}).then(res => {
					if (res.status == 200) {
						this.province_area = res.data;
						this.city[1].b = 0;
						this.city[1].name = '';
						this.city[2].m = 0;
						this.city[2].name = '';
					} else {
						this.$api.msg('获取失败');
					}
				});
			},
			get_area(e) {
				this.city[1].b = e[0].value;
				this.city[1].name = e[0].label;
				//选择域
				let parent_id = this.city[1].b;
				if (parent_id == 0) {
					return;
				}
				api.getTwon({
					level: 3,
					parent_id: parent_id
				}).then(res => {
					if (res.status == 200) {

						this.province_twon = res.data;
						this.city[2].m = 0;
						this.city[2].name = '';
					} else {
						this.$api.msg('获取失败');
					}
				});
			},
			get_twon(e) {
				this.city[2].m = e[0].value;
				this.city[2].name = e[0].label;
			},
			search_pickup() {
				if (this.province.length == 0) {
					this.$api.msg('请选择省份!');
					return;
				}

				let that = this;
				/*#ifdef MP */
				uni.showToast({
					title: '加载自提点中...'
				});
				uni.authorize({
					scope: 'scope.userLocation',
					success() {
						uni.getLocation({
							type: 'gcj02',
							success: function(res) {
								var latitude = res.latitude; // 纬度，浮点数，范围为90 ~ -90
								var longitude = res.longitude; // 经度，浮点数，范围为180 ~ -180。
								var speed = res.speed; // 速度，以米/每秒计
								var accuracy = res.accuracy; // 位置精度
								var pickups = that.orderList.pickups;
								console.log(pickups);
								if (pickups != '') {
									let obj = {
										latitude,
										longitude,
										province: that.city[0].s,
										city: that.city[1].b,
										district: that.city[2].m,
										pickups
									};
									cart.pickup(obj).then(data => {
										if (data.status == 200) {
											if (data.data.info) {
												that.demoHtml = data.data.info;
												uni.hideLoading();
											}
										} else {
											that.$api.msg('获取失败');
											uni.hideLoading();
										}
									});
								}
							}
						});
					}
				});
				/* #endif*/
			},
			/* 优惠券*/
			mask(e, flag) {
				console.log(e);

				/* 还原*/
				this.orderList.payprice = this.clone.payprice;
				this.preferential = 0; // 优惠金额
				this.clamp = '选择优惠券';
				/* 还原*/
				if (flag) {
					this.djqid = 0;
					this.toggleMask(0);
					return;
				}
				let totalprice = this.orderList.totalprice; // 商品金额
				if (totalprice < e.usemoney) {
					this.$refs.uTips.show({
						title: '价格不足 无法使用!',
						type: 'error',
						duration: '2300'
					});
					return;
				}
				this.djqid = e.id; // 代金券id
				this.orderList.payprice > e.money ? (this.orderList.payprice -= e.money) : (this.orderList.payprice =
					0); // 价格

				this.preferential = e.money; // 优惠金额
				this.clamp = '满' + e.usemoney + '减' + e.money;
				this.toggleMask(0);
			},
			//显示优惠券面板
			toggleMask(type) {
				if (this.orderList.djq.length > 0) {
					this.showPay = true
				}

				let timer = type === 'show' ? 10 : 300;
				let state = type === 'show' ? 1 : 0;
				this.maskState = 2;
				setTimeout(() => {
					this.maskState = state;
				}, timer);
			},
			/* 获取订单信息*/
			orderIndex(option) {
				api.shop_orderMake(option).then(res => {
					console.log(res,'resddd');
					if (res.status == 200) {
						this.orderList = res.data;
						this.opayprice = this.orderList.payprice
						this.clone = this.$u.deepClone(res.data);
						this.province = res.data.province;
						this.login = false;
						this.istd = this.orderList.cache[0].soil_num > 0 
					} else if (res.status == 402) {
						this.$api.msg(res.msg);
						this.ifpeon = false
					} else {
						this.$api.msg(res.msg);
						this.login = false;
					}
				});
			},
			getAddressData(option) {
				api_address.address().then(res => {
					console.log(res, "address");
					if (res.status == 200) {
						if (res.data) {
							let is_default = res.data.data.filter(item => item.is_default == 1);
							this.addressData = is_default[0];
						}
						this.orderIndex(option);
					} else {
						this.$api.msg(res.msg);
					}
				});
			},
			numberChange(data) {
				this.number = data.number;
			},
			changePayType(type) {
				this.payType = type;
			},
			submit() {
				let that = this
				if (!that.addressData && that.flag) {
					that.$api.msg('请选择收货地址!');
					return;
				}
				let tmplIdsone = that.$config.temlist;
				if (tmplIdsone) {
					that.$until.requestSubscribeMessage([tmplIdsone['orderSuccess'], tmplIdsone['orderDelivery']],
						tmplIdsone,
						function() {
							that.orderMake();
						});
				}else{
					that.orderMake();
				}
			},
			stopPrevent() {}
		}
	};
</script>
<style lang="scss">
	* {
		list-style: none;
	}

	.goreins {
		margin-top: 30upx;
		display: flex;
		align-items: center;
		justify-content: center;
		width: 600upx;
		height: 80upx;
		font-size: $font-lg;
		color: #fff;
		background: $tab-color;
		border-radius: 10upx;
		margin: 25rpx auto 0 auto;

		&.hollow {
			background: #fff;
			color: #303133;
			border: 1px solid #ccc;
		}
	}

	.loading {
		position: absolute;
		left: 48%;
		top: 50%;
	}

	.tag {
		width: 100%;
		height: 106rpx;
		background-color: #fff;
		display: flex;
		margin-top: 10rpx;
		margin-bottom: 10rpx;

		.tag_box {
			flex: 1;
			text-align: center;
			line-height: 106rpx;
			font-size: 24rpx;
			border-bottom: 1rpx solid #999999;
		}
	}

	.tag_active {
		border-bottom: 1rpx solid $tab-color-2 !important;
	}

	.ziti {
		width: 100%;
		padding: 56rpx 28rpx;
		box-sizing: border-box;

		.ziti_city {
			display: flex;
			justify-content: space-around;

			select {
				border: 1px solid #dad8cd;
				min-width: 180rpx;
			}
		}

		.search_pickup {
			color: red;
			width: 250rpx;
			height: 56rpx;
			text-align: center;
			line-height: 56rpx;
			color: #04be02;
			border: 1px solid #04be02;
			border-radius: 10rpx;
			margin: 50rpx auto 0;
		}

		.since {
			width: 90%;
			border-top: 1rpx dashed #999999;
			margin: 30rpx auto 0;
		}

		.not-arrow {
			width: 200rpx;
			height: 54rpx;
			padding: 5px 10px;
			border: 1px solid #dcd8d8;
			box-sizing: border-box;
			display: flex;
			align-items: center;
		}
	}

	.address-section {
		padding: 10rpx 10rpx 15rpx 10rpx;
		background: #fff;
		position: relative;

		.order-content {
			display: flex;
			align-items: center;
		}

		.icon-shouhuodizhi {
			flex-shrink: 0;
			display: flex;
			align-items: center;
			justify-content: center;
			width: 90upx;
			color: #888;
			font-size: 44upx;
		}

		.cen {
			display: flex;
			flex-direction: column;
			flex: 1;
			font-size: 28upx;
			color: $font-color-dark;
		}

		.name {
			font-size: 34upx;
			margin-right: 24upx;
		}

		.address {
			margin-top: 16upx;
			margin-right: 20upx;
			color: $font-color-light;
		}

		.icon-you {
			font-size: 32upx;
			color: $font-color-light;
			margin-right: 30upx;
		}

		.a-bg {
			position: absolute;
			left: 0;
			bottom: 0;
			display: block;
			width: 100%;
			height: 5upx;
		}
	}

	.goods-section {
		margin-top: 16upx;
		background: #fff;
		padding-bottom: 1px;
		padding-top: 10rpx;

		.g-header {
			display: flex;
			align-items: center;
			height: 84upx;
			padding: 0 30upx;
			position: relative;
		}

		.logo {
			display: block;
			width: 50upx;
			height: 50upx;
			border-radius: 100px;
		}

		.name {
			font-size: 30upx;
			color: $font-color-base;
			margin-left: 24upx;
		}

		.g-item {
			display: flex;
			margin: 20upx 30upx;

			image {
				flex-shrink: 0;
				display: block;
				width: 140upx;
				height: 140upx;
				border-radius: 8upx;
			}

			.right {
				flex: 1;
				padding-left: 24upx;
				overflow: hidden;

				.title {
					font-size: 30upx;
					color: $font-color-dark;
					height: 40rpx;
					line-height: 40rpx;
				}

				.spec {
					margin-top: 40rpx;
					font-size: 26upx;
					color: $font-color-light;
				}

				.price-box {
					display: flex;
					align-items: center;
					font-size: 32upx;
					color: $font-color-dark;
					padding-top: 20rpx;

					.price {
						margin-bottom: 4upx;
					}

					.number {
						font-size: 26upx;
						color: $font-color-base;
						margin-left: 20upx;
					}
				}
			}


			.step-box {
				position: relative;
			}
		}
	}

	.yt-list {
		margin-top: 16upx;
		background: #fff;
	}

	.yt-list-cell {
		display: flex;
		align-items: center;
		padding: 10upx 30upx 10upx 40upx;
		line-height: 70upx;
		position: relative;

		&.cell-hover {
			background: #fafafa;
		}

		&.b-b:after {
			left: 30upx;
		}

		.cell-icon {
			height: 32upx;
			width: 32upx;
			font-size: 22upx;
			color: #fff;
			text-align: center;
			line-height: 32upx;
			background: #f85e52;
			border-radius: 4upx;
			margin-right: 12upx;

			&.hb {
				background: #ffaa0e;
			}

			&.lpk {
				background: #3ab54a;
			}
		}

		.cell-more {
			align-self: center;
			font-size: 24upx;
			color: $font-color-light;
			margin-left: 8upx;
			margin-right: -10upx;
		}

		.cell-tit {
			flex: 1;
			font-size: 26upx;
			color: $font-color-light;
			margin-right: 10upx;
		}

		.cell-tip {
			font-size: 26upx;

			&.disabled {
				color: $font-color-light;
			}

			&.active {
				color: $base-color;
			}
		}

		&.desc-cell {
			.cell-tit {
				max-width: 90upx;
			}
		}

		.desc {
			flex: 1;
			font-size: $font-base;
			color: $font-color-dark;
		}
	}

	/* 支付列表 */
	.pay-list {
		padding-left: 40upx;
		margin-top: 16upx;
		background: #fff;

		.pay-item {
			display: flex;
			align-items: center;
			padding-right: 20upx;
			line-height: 1;
			height: 110upx;
			position: relative;
		}

		.icon-weixinzhifu {
			width: 80upx;
			font-size: 40upx;
			color: #6bcc03;
		}

		.icon-alipay {
			width: 80upx;
			font-size: 40upx;
			color: #06b4fd;
		}

		.icon-xuanzhong2 {
			display: flex;
			align-items: center;
			justify-content: center;
			width: 60upx;
			height: 60upx;
			font-size: 40upx;
			color: $base-color;
		}

		.tit {
			font-size: 32upx;
			color: $font-color-dark;
			flex: 1;
		}
	}

	.footer {
		position: fixed;
		left: 0;
		bottom: 0;
		z-index: 995;
		display: flex;
		align-items: center;
		width: 100%;
		height: 90upx;
		justify-content: space-between;
		font-size: 30upx;
		background-color: #fff;
		z-index: 998;
		color: $font-color-base;
		box-shadow: 0 -1px 5px rgba(0, 0, 0, 0.1);

		.price-content {
			padding-left: 30upx;
		}

		.price-tip {
			margin-left: 8upx;
		}

		.price {
			font-size: 36upx;
		}

		.submit {
			display: flex;
			align-items: center;
			justify-content: center;
			width: 280upx;
			height: 100%;
			color: #fff;
			font-size: 32upx;
		}
	}

	/* 优惠券面板 */
	.mask {
		display: flex;
		align-items: flex-end;
		position: fixed;
		left: 0;
		top: var(--window-top);
		bottom: 0;
		width: 100%;
		background: rgba(0, 0, 0, 0);
		z-index: 9995;
		transition: 0.3s;

		.mask-content {
			width: 100%;
			min-height: 30vh;
			max-height: 70vh;
			background: #f3f3f3;
			transform: translateY(100%);
			transition: 0.3s;
			overflow-y: scroll;
		}

		&.none {
			display: none;
		}

		&.show {
			background: rgba(0, 0, 0, 0.4);

			.mask-content {
				transform: translateY(0);
			}
		}
	}

	/* 优惠券列表 */
	.coupon-item {
		display: flex;
		flex-direction: column;
		margin: 20upx 24upx;
		background: #fff;

		.con {
			display: flex;
			align-items: center;
			position: relative;
			height: 120upx;
			padding: 0 30upx;

			&:after {
				position: absolute;
				left: 0;
				bottom: 0;
				content: '';
				width: 100%;
				height: 0;
				border-bottom: 1px dashed #f3f3f3;
				transform: scaleY(50%);
			}
		}

		.left {
			display: flex;
			flex-direction: column;
			justify-content: center;
			flex: 1;
			overflow: hidden;
			height: 100upx;
		}

		.title {
			font-size: 32upx;
			color: $font-color-dark;
			margin-bottom: 20upx;
		}

		.time {
			font-size: 24upx;
			color: $font-color-light;
		}

		.right {
			display: flex;
			flex-direction: column;
			justify-content: center;
			align-items: center;
			font-size: 26upx;
			color: $font-color-base;
			height: 100upx;
		}

		.price {
			font-size: 44upx;
			color: $base-color;
			margin-bottom: 20rpx;

			&:before {
				content: '￥';
				font-size: 34upx;
			}
		}

		.tips {
			font-size: 24upx;
			color: $font-color-light;
			line-height: 60upx;
			padding-left: 30upx;
		}

		.circle {
			position: absolute;
			left: -6upx;
			bottom: -10upx;
			z-index: 10;
			width: 20upx;
			height: 20upx;
			background: #f3f3f3;
			border-radius: 100px;

			&.r {
				left: auto;
				right: -6upx;
			}
		}
	}
</style>
